pcl::io::LZFBayer8ImageReader Class Reference
Module io

PCL-LZF 8-bit Bayer image format reader. More...

`#include <pcl/io/lzf_image_io.h>`

Inheritance diagram for pcl::io::LZFBayer8ImageReader:

## Public Member Functions

| LZFBayer8ImageReader ()
| Empty constructor. More...
| ~LZFBayer8ImageReader ()
| Empty destructor. More...
template<typename PointT >
bool | read (const std::string &filename, pcl::PointCloud< PointT > &cloud)
| Read the data stored in a PCLZF Bayer 8bit file and convert it to a pcl::PointCloud type. More...
template<typename PointT >
bool | readOMP (const std::string &filename, pcl::PointCloud< PointT > &cloud, unsigned int num_threads=0)
| Read the data stored in a PCLZF Bayer 8bit file and convert it to a pcl::PointCloud type. More...
bool | readParameters (std::istream &is) override
| Read camera parameters from a given stream and store them internally. More...
bool | readParameters (const std::string &filename)
| Read camera parameters from a given file and store them internally. More...
virtual bool | readParameters (std::istream &)
| Read camera parameters from a given stream and store them internally. More...
Public Member Functions inherited from pcl::io::LZFRGB24ImageReader
| LZFRGB24ImageReader ()
| Empty constructor. More...
| ~LZFRGB24ImageReader ()
| Empty destructor. More...
template<typename PointT >
bool | read (const std::string &filename, pcl::PointCloud< PointT > &cloud)
| Read the data stored in a PCLZF RGB file and convert it to a pcl::PointCloud type. More...
template<typename PointT >
bool | readOMP (const std::string &filename, pcl::PointCloud< PointT > &cloud, unsigned int num_threads=0)
| Read the data stored in a PCLZF RGB file and convert it to a pcl::PointCloud type. More...
bool | readParameters (std::istream &is) override
| Read camera parameters from a given stream and store them internally. More...
bool | readParameters (const std::string &filename)
| Read camera parameters from a given file and store them internally. More...
virtual bool | readParameters (std::istream &)
| Read camera parameters from a given stream and store them internally. More...
Public Member Functions inherited from pcl::io::LZFImageReader
| LZFImageReader ()
| Empty constructor. More...
virtual | ~LZFImageReader ()
| Empty destructor. More...
bool | readParameters (const std::string &filename)
| Read camera parameters from a given file and store them internally. More...
void | setParameters (const CameraParameters &parameters)
| Read the parameters from a struct instead. More...
CameraParameters | getParameters () const
| Get the camera parameters currently being used returns a CameraParameters struct. More...
std::uint32_t | getWidth () const
| Get the image width as read from disk. More...
std::uint32_t | getHeight () const
| Get the image height as read from disk. More...
std::string | getImageType () const
| Get the type of the image read from disk. More...

## Additional Inherited Members

Protected Member Functions inherited from pcl::io::LZFImageReader
bool | loadImageBlob (const std::string &filename, std::vector< char > &data, std::uint32_t &uncompressed_size)
| Load a compressed image array from disk. More...
bool | decompress (const std::vector< char > &input, std::vector< char > &output)
| Realtime LZF decompression. More...
Protected Attributes inherited from pcl::io::LZFImageReader
std::uint32_t | width_
| The image width, as read from the file. More...
std::uint32_t | height_
| The image height, as read from the file. More...
std::string | image_type_identifier_
| The image type string, as read from the file. More...
CameraParameters | parameters_
| Internal set of camera parameters. More...

## Detailed Description

PCL-LZF 8-bit Bayer image format reader.

The main advantage of using the PCL-LZF image I/O routines is a very good file size versus I/O speed ratio. Tests performed using LZF, Snappy, ZIP, GZ2, BZIP2, as well as PNG, JPEG, and TIFF compression have shown that the internal PCL LZF methods provide the best score for the types of applications PCL is suited for.

Author
  Radu B. Rusu

Definition at line 324 of file lzf_image_io.h.

## Constructor & Destructor Documentation

## LZFBayer8ImageReader()

pcl::io::LZFBayer8ImageReader::LZFBayer8ImageReader | ( |  | ) |

inline

Empty constructor.

Definition at line 330 of file lzf_image_io.h.

## ~LZFBayer8ImageReader()

pcl::io::LZFBayer8ImageReader::~LZFBayer8ImageReader | ( |  | ) |

inline

Empty destructor.

Definition at line 332 of file lzf_image_io.h.

## Member Function Documentation

## read()

template<typename PointT >

bool pcl::io::LZFBayer8ImageReader::read | ( | const std::string & | filename,
|  | pcl::PointCloud< PointT > & | cloud
| ) |  |

Read the data stored in a PCLZF Bayer 8bit file and convert it to a pcl::PointCloud type.

Parameters

  [in] | filename | the file name to read the data from
  [out] | cloud | the resultant output point cloud

Definition at line 436 of file lzf_image_io.hpp.

References pcl::io::DeBayer::debayerEdgeAware(), pcl::io::LZFImageReader::decompress(), pcl::io::LZFImageReader::getHeight(), pcl::io::LZFImageReader::getImageType(), pcl::io::LZFImageReader::getWidth(), pcl::PointCloud< PointT >::height, pcl::io::LZFImageReader::loadImageBlob(), pcl::PointCloud< PointT >::resize(), pcl::PointCloud< PointT >::size(), and pcl::PointCloud< PointT >::width.

## readOMP()

template<typename PointT >

bool pcl::io::LZFBayer8ImageReader::readOMP | ( | const std::string & | filename,
|  | pcl::PointCloud< PointT > & | cloud,
|  | unsigned int | num_threads = `0`
| ) |  |

Read the data stored in a PCLZF Bayer 8bit file and convert it to a pcl::PointCloud type.

Note that, unless massively multithreaded, this will likely not result in a significant speedup and may even slow performance.

Parameters

  [in] | filename | the file name to read the data from
  [in] | num_threads | The number of threads to use
  [out] | cloud | the resultant output point cloud

Definition at line 486 of file lzf_image_io.hpp.

References pcl::io::DeBayer::debayerEdgeAware(), pcl::io::LZFImageReader::decompress(), pcl::io::LZFImageReader::getHeight(), pcl::io::LZFImageReader::getImageType(), pcl::io::LZFImageReader::getWidth(), pcl::PointCloud< PointT >::height, pcl::utils::ignore(), pcl::io::LZFImageReader::loadImageBlob(), pcl::PointCloud< PointT >::resize(), pcl::PointCloud< PointT >::size(), and pcl::PointCloud< PointT >::width.

## readParameters() [1/3]

bool pcl::io::LZFImageReader::readParameters

Read camera parameters from a given file and store them internally.

Returns
  true if operation successful, false otherwise

## readParameters() [2/3]

virtual bool pcl::io::LZFImageReader::readParameters

inline

Read camera parameters from a given stream and store them internally.

Returns
  true if operation successful, false otherwise

Definition at line 242 of file lzf_image_io.h.

## readParameters() [3/3]

bool pcl::io::LZFRGB24ImageReader::readParameters

override

Read camera parameters from a given stream and store them internally.

The parameters will be read from the <rgb> ... </rgb> tag.

Returns
  true if operation successful, false otherwise

The documentation for this class was generated from the following files:

- pcl/io/lzf_image_io.h
- pcl/io/impl/lzf_image_io.hpp